/*
 * $Id$
 */

package org.apache.maven.continuum.xmlrpc.project;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;
import org.apache.maven.continuum.xmlrpc.scm.ChangeFile;
import org.apache.maven.continuum.xmlrpc.scm.ChangeSet;
import org.apache.maven.continuum.xmlrpc.scm.ScmResult;
import org.apache.maven.continuum.xmlrpc.system.Installation;
import org.apache.maven.continuum.xmlrpc.system.Profile;

/**
 * 
 *         This class is a summary of a single continuum build.
 *       
 * 
 * @version $Revision$ $Date$
 */
public class BuildResult extends BuildResultSummary 
implements java.io.Serializable
{


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field scmResult
     */
    private ScmResult scmResult;

    /**
     * Field changesSinceLastSuccess
     */
    private java.util.List changesSinceLastSuccess;

    /**
     * Field modifiedDependencies
     */
    private java.util.List modifiedDependencies;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addChangesSinceLastSucces
     * 
     * @param changeSet
     */
    public void addChangesSinceLastSucces(ChangeSet changeSet)
    {
        if ( !(changeSet instanceof ChangeSet) )
        {
            throw new ClassCastException( "BuildResult.addChangesSinceLastSuccess(changeSet) parameter must be instanceof " + ChangeSet.class.getName() );
        }
        getChangesSinceLastSuccess().add( changeSet );
    } //-- void addChangesSinceLastSucces(ChangeSet) 

    /**
     * Method addModifiedDependency
     * 
     * @param projectDependency
     */
    public void addModifiedDependency(ProjectDependency projectDependency)
    {
        if ( !(projectDependency instanceof ProjectDependency) )
        {
            throw new ClassCastException( "BuildResult.addModifiedDependencies(projectDependency) parameter must be instanceof " + ProjectDependency.class.getName() );
        }
        getModifiedDependencies().add( projectDependency );
    } //-- void addModifiedDependency(ProjectDependency) 

    /**
     * Method getChangesSinceLastSuccess
     */
    public java.util.List getChangesSinceLastSuccess()
    {
        if ( this.changesSinceLastSuccess == null )
        {
            this.changesSinceLastSuccess = new java.util.ArrayList();
        }
        
        return this.changesSinceLastSuccess;
    } //-- java.util.List getChangesSinceLastSuccess() 

    /**
     * Method getModifiedDependencies
     */
    public java.util.List getModifiedDependencies()
    {
        if ( this.modifiedDependencies == null )
        {
            this.modifiedDependencies = new java.util.ArrayList();
        }
        
        return this.modifiedDependencies;
    } //-- java.util.List getModifiedDependencies() 

    /**
     * Get null
     */
    public ScmResult getScmResult()
    {
        return this.scmResult;
    } //-- ScmResult getScmResult() 

    /**
     * Method removeChangesSinceLastSucces
     * 
     * @param changeSet
     */
    public void removeChangesSinceLastSucces(ChangeSet changeSet)
    {
        if ( !(changeSet instanceof ChangeSet) )
        {
            throw new ClassCastException( "BuildResult.removeChangesSinceLastSuccess(changeSet) parameter must be instanceof " + ChangeSet.class.getName() );
        }
        getChangesSinceLastSuccess().remove( changeSet );
    } //-- void removeChangesSinceLastSucces(ChangeSet) 

    /**
     * Method removeModifiedDependency
     * 
     * @param projectDependency
     */
    public void removeModifiedDependency(ProjectDependency projectDependency)
    {
        if ( !(projectDependency instanceof ProjectDependency) )
        {
            throw new ClassCastException( "BuildResult.removeModifiedDependencies(projectDependency) parameter must be instanceof " + ProjectDependency.class.getName() );
        }
        getModifiedDependencies().remove( projectDependency );
    } //-- void removeModifiedDependency(ProjectDependency) 

    /**
     * Set null
     * 
     * @param changesSinceLastSuccess
     */
    public void setChangesSinceLastSuccess(java.util.List changesSinceLastSuccess)
    {
        this.changesSinceLastSuccess = changesSinceLastSuccess;
    } //-- void setChangesSinceLastSuccess(java.util.List) 

    /**
     * Set null
     * 
     * @param modifiedDependencies
     */
    public void setModifiedDependencies(java.util.List modifiedDependencies)
    {
        this.modifiedDependencies = modifiedDependencies;
    } //-- void setModifiedDependencies(java.util.List) 

    /**
     * Set null
     * 
     * @param scmResult
     */
    public void setScmResult(ScmResult scmResult)
    {
        this.scmResult = scmResult;
    } //-- void setScmResult(ScmResult) 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
